#include "mouseapiexample.h"
#include "gametypes/Gametype.h"
#include "infos/PlayerInfo.h"
#include "worldentities/CameraPosition.h"
#include "worldentities/ControllableEntity.h"

namespace orxonox
{

RegisterClass(MouseAPIExample);

MouseAPIExample::MouseAPIExample(Context* context) : ControllableEntity(context)
{
    RegisterObject(MouseAPIExample);
}

MouseAPIExample::~MouseAPIExample()
{
    if(MouseAPI::isActive())
        MouseAPI::getInstance().deactivate();

}

void MouseAPIExample::testfunction(MouseButtonCode::ByEnum mouse)
{
    float randomnumber = (rand()%100 + 1)/20.0;
    this->setScale(randomnumber);
    orxout() << "Blah\n";
    //this->getGametype()->getPlayers().begin()->first->getControllableEntity()->mouseLook();//getCurrentCameraPosition()->setAllowMouseLook(false);
    //this->getGametype()->getPlayers().begin()->first->stopControl();

}

void MouseAPIExample::XMLPort(Element& xmlelement, XMLPort::Mode mode)
{
    SUPER(MouseAPIExample, XMLPort, xmlelement, mode);
    MouseAPI::getInstance().activate();
    MouseAPI::getInstance().addClickableObject(this->getWorldPosition(),10,std::list<MouseButtonCode::ByEnum>{MouseButtonCode::Left},[this](MouseButtonCode::ByEnum mouse){this->testfunction(mouse);});
    //this->getGametype()->getPlayers().begin()->first->getControllableEntity()->mouseLook();


}
}
